/*
 *   snortconf - configuration tool for snort.conf
 *
 *   Copyright (C) 2001 ManISec, Inc.
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* Yee ole includes (I put this all in one file for my sanity) */
#include "include.h"

/* Yee ole main() (short and sweet) */

void curs_init() {

        /* ncurses init */
	initscr();                      /* initialize the screen                */
	clear();                        /* clear any screen trash               */
	keypad(stdscr, TRUE);           /* enable the keypad                    */
	nonl();                         /* fix newline translations             */
	intrflush(stdscr, FALSE);       /* I forget, but it's good. :)          */
	scrollok(stdscr, TRUE);         /* turn on scrolling capabilities       */
	noecho();			/* don't echo to screen			*/
							
	/* see about wether or not we got colors to use */
	if (has_colors() == TRUE) {
		/* hey, we got color, initialize the stuff so's we can use it 	*/
		color = TRUE;     /* global "we got color" true/false var */
                start_color();
                init_pair(COLOR_BLACK, COLOR_BLACK, COLOR_BLACK);
                init_pair(COLOR_GREEN, COLOR_GREEN, COLOR_BLACK);
                init_pair(COLOR_RED, COLOR_RED, COLOR_BLACK);
                init_pair(COLOR_CYAN, COLOR_CYAN, COLOR_BLACK);
                init_pair(COLOR_WHITE, COLOR_WHITE, COLOR_BLACK);
                init_pair(COLOR_MAGENTA, COLOR_MAGENTA, COLOR_BLACK);
                init_pair(COLOR_BLUE, COLOR_BLUE, COLOR_BLACK);
                init_pair(COLOR_YELLOW, COLOR_YELLOW, COLOR_BLACK);
        } else {
		/* no colors - oh well, we'll do our best with A_REVERSE 	*/
		color = FALSE;
        }

}
