/*
 *   snortconf - configuration tool for snort.conf
 *
 *   Copyright (C) 2001 ManISec, Inc.
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* Yee ole includes (I put this all in one file for my sanity) */
#include "include.h"

/* special menu to configure the output_db plugin (long winded code, should probably
 * be in separate file and broken up into sub-functions for cleanliness sake, but it
 * works as-is, so I'm in no rush :)	*/

int output_db_config() {
	short int sel = 0;
	int key = 'Z';
	
	int x, y, w, h; /* a character, x/y cordinates, and width/height definitions    */
        WINDOW *win;

        x = ((LINES / 2) - 10);                            /* center X cordinate   */
        y = 0;  /* center Y cordinate   */
        w = COLS;                               	/* figure width         */
        h = 10;                                          /* all these are 5 high */

        win = newwin(h, w, x, y);                       /* create a new window  */

        noecho();                                       /* turn off echo keystrokes     */
        keypad(win, TRUE);                              /* enable use of keypad */

        while(key != 'q') {
		
		wmove(win, 1, 0);

		if(sel == 0) wsel_color_set(win);
		wprintw(win, " Database Type:            ");
		if(sel == 0) wstandend(win);
			switch(output.db_type) {
				case MYSQL:
					if(sel == 0) wprintw(win, "  MySQL         (spacebar toggle)\n");
					else wprintw(win, "  MySQL\n");
					break;
				case PGSQL:
					if(sel == 0) wprintw(win, "  PostgreSQL    (spacebar toggle)\n");
					else wprintw(win, "  PostgreSQL\n");
					break;
				case MSSQL:
					if(sel == 0) wprintw(win, "  Micro$oft SQL (spacebar toggle)\n");
					else wprintw(win, "  Micro$oft SQL\n");
					break;
				case ODBC:
					if(sel == 0) wprintw(win, "  UNIX ODBC     (spacebar toggle)\n");
					else wprintw(win, "  UNIX ODBC\n");
					break;
				case ORACLE:
					if(sel == 0) wprintw(win, "  Oracle        (spacebar toggle)\n");
					else wprintw(win, "  Oracle\n");
					break;

					
			}
	
		if(sel == 1) wsel_color_set(win);
		wprintw(win, " Database User:            ");
		if(sel == 1) wstandend(win);
		wprintw(win, "  %s\n", output.db_user);
	
		if(sel == 2) wsel_color_set(win);
		wprintw(win, " Database Password:        ");
		if(sel == 2) wstandend(win);
		wprintw(win, "  %s\n", output.db_pass);

		if(sel == 3) wsel_color_set(win);
		wprintw(win, " Database Name:            ");
		if(sel == 3) wstandend(win);
		wprintw(win, "  %s\n", output.db_name);
	
		if(sel == 4) wsel_color_set(win);
		wprintw(win, " Database Host:            ");
		if(sel == 4) wstandend(win);
		wprintw(win, "  %s\n", output.db_host);

		if(sel == 5) wsel_color_set(win);
		wprintw(win, " Database Port (optional): ");
		if(sel == 5) wstandend(win);
		wprintw(win, "  %s\n", output.db_port);
		
		if(sel == 6) wsel_color_set(win);
		wprintw(win, "\n [Q]uit (return)         ");
		if(sel == 6) wstandend(win);
	

        	box(win, ACS_VLINE, ACS_HLINE);
	        wrefresh(win);
		key = wgetch(win);
		key = tolower(key);

		switch(key) {
			case KEY_DOWN:
			case 'd':
				if(sel < 6) ++sel;
				break;
			case KEY_UP:
			case 'u':
				if(sel > 0) --sel;
				break;
			case 13:
			case ' ':
				if(sel == 0 && key == 13) {
					key = 'q';
					break;
				}
				
				if(sel == 0) {
					if(output.db_type > 3) 
						output.db_type = 0;
					else 
						++output.db_type;
				} else {

					if(sel == 1) strcpy(output.db_user, popup_getval("Enter the name of the user with write access to the database: "));
					if(sel == 2) strcpy(output.db_pass, popup_getval("Enter the password to access the database: "));
					if(sel == 3) strcpy(output.db_name, popup_getval("Enter the name of the database: "));

					if(sel == 4) {
						strcpy(output.db_host, popup_getval("Enter the host (IP address) on which the database resides: "));
						if(snc_check_ip(output.db_host) == FALSE) {
							do_popup("ERROR: That is not a valid IP address!", PERR);
							output.db_host[0] = '\0';
							break;
						}
					}
					if(sel == 5) {
					       	strcpy(output.db_port, popup_getval("Enter the port on which the database listens for connections: "));
						if(snc_check_port(output.db_port) == FALSE) {
							do_popup("ERROR: Invalid port number entered!", PERR);
							output.db_port[0] = '\0';
							break;
						}
					}
					if(sel == 6) key = 'q';

					++sel;
				}
				break;
			case '?':
				if(sel == 0) menu_help_var("Toggle the database type.\n\nToggle through the options until your database type is displayed\n");
				if(sel == 1) menu_help_var("Set the DB username.\n\nSet this value to the name of the user which has write access to your database\n\n(REQUIRED)");
				if(sel == 2) menu_help_var("Set the DB password.\n\nSet this value to the DB password of the user entered above\n\n(REQUIRED)\n\nYes, REQUIRED.  Passwordless DB's are a BAD idea.\n");
				if(sel == 3) menu_help_var("Set the DB name.\n\nSet this value to the name of the database which you configured for Snort to use as it's data repository\n\n(REQUIRED)");
				if(sel == 4) menu_help_var("Set the DB host.\n\nSet this value to the IP address of the server on which the database resides. (ie: 127.0.0.1)\n\n(REQUIRED)");
				if(sel == 5) menu_help_var("Set the DB port.\n\nIf your database application listens on a non-standard port, you should indicate what port is listens on here\n\n(OPTIONAL)");
				if(sel == 6) menu_help_var("Quit and return to the Output Pluging Config menu\n\nIf all options are not filled in, the DB output plugin will not be activated.");
				break;


		}
		touchwin(stdscr);
		refresh();
		
	}
	
	
	delwin(win);
	if(output.db_user[0] != '\0' && output.db_pass[0] != '\0' && output.db_name[0] != '\0' && output.db_host[0] != '\0') {
		return TRUE;
	} else {
		return FALSE;
	}

	return FALSE;
		
}

/* yee ole print menu function to keep the menu code itself cleaner */
int output_print_menu(int sel) {
	
	short int i, on = FALSE;	

	char *menu_item[] = {
		"Syslog output               ", 
		"Tcpdump binary output       ",
		"Database output             ",
		"XML logging                 ",
		"Unified binary output       ", 
		"SNMP Trap alerting          ",
		"[Q]uit (return to main menu)",
		NULL 
	};
	
	clear(); /* clear yee ole ncurses screen */

	print_title_bar();
	
	/* REALLY ugly amount of code here - I should do this differently to avoid it :) */
	for (i = 0 ; menu_item[i] != NULL  ; i++) {
		on = FALSE;
		if(i == 0 && output.syslog == TRUE) on = TRUE;
		if(i == 1 && output.tcpdump == TRUE) on = TRUE;
		if(i == 2 && output.database == TRUE) on = TRUE;
		if(i == 3 && output.xml == TRUE) on = TRUE;
		if(i == 4 && output.unified == TRUE) on = TRUE;
		if(i == 5 && output.snmp == TRUE) on = TRUE;
		
		if(i != 6) {
			if(on == TRUE) {
				if(color == TRUE) {
					printw("[");
					attr_on(COLOR_PAIR(COLOR_GREEN|A_BOLD), NULL);
					printw("ON");
					standend();
					printw("]  ");
				} else {
				printw("[ON]  ");
				}
			} else {
				if(color == TRUE) {
					printw("[");
					attr_on(COLOR_PAIR(COLOR_RED|A_BOLD), NULL);
					printw("OFF");
					standend();
					printw("] ");
				} else {
				printw("[OFF] ");
				}
			}
		} else {
			if(i == 6) printw("\n");
			printw("      ");
		}
		
		if(sel == i) sel_color_set();
		printw("%s", menu_item[i]);
		if(sel == i) standend();
		printw("\n");
		
	}
	return 0;

}

/* put ugly help-text calls in here to clean up main menu code 	*/
void output_config_menu_help(int sel) {
	if(sel == 0) menu_help_var("Syslog Output\n\nEnable the sending of alert messages via syslog\n");
	if(sel == 1) menu_help_var("Tcpdump Binary Output\n\nEnable the logging of all \"bad packets\" to a tcpdump formatted binary file for later analysis using any one of the wide range of tools which supports this file format.\n");
	if(sel == 2) menu_help_var("Database Output\n\nEnable the logging of alerts to a database.\n");
	if(sel == 3) menu_help_var("XML Output\n\nEnable logging to XML file (/var/log/snortxml)\n");
	if(sel == 4) menu_help_var("Unified Output\n\nEnable \"unified\" style logging.  If you don't know what this means, say NO!\n");
	if(sel == 5) menu_help_var("SNMP Trap based alerting.\n\nAs of yet, snortconf does not allow configuration of this option.");
	if(sel == 6) menu_help_var("Quit and return to the main menu.\n");
}

/* yee ole code what makes the menu do it's thing */
int output_config_menu() {

	int key = 0;
	int sel = 0; 

	while(key != 'q') {
		output_print_menu(sel);
		key = getch();
		key = tolower(key);
	
		switch(key) {
			case KEY_UP:
			case 'u':
			case 'k':
			case 'p':
			       if(sel > 0) --sel;
			       break;
			case KEY_DOWN:
			case 'd':
			case 'j':
			case 'n':
			       if(sel < 6) ++sel;
			       break;
			case 13:
			case ' ':
				if(sel == 0) output.syslog = toggle_flag(output.syslog);
				if(sel == 1) output.tcpdump = toggle_flag(output.tcpdump);
				if(sel == 2) { 
					if(output.database == TRUE) {
						output.database = FALSE;
					} else if(output_db_config() == TRUE) {
						output.database = TRUE;
					} else {
						do_popup("ERROR: REQUIRED options not filled in!", PERR);
					}
				}
				if(sel == 3) {
					if(output.xml == FALSE) menu_help_var("\tThis will enable XML logging to the file /var/log/snortxml\n\nFor remote XML logging, you will need to edit snort.conf by hand!");
					output.xml = toggle_flag(output.xml);
				}
				if(sel == 4) output.unified = toggle_flag(output.unified);	
				if(sel == 5) do_popup("Configuration of this item not yet supported by SnortConf", HIT_OK); /* output.snmp = toggle_flag(output.snmp);	 */
				if(sel == 6) key = 'q';	
			      	break; 
			case '?':
				output_config_menu_help(sel);
				break;
		}
	}
	/* someday we error check, and return values based on what we see	*/	
	return 0;
	
}
	
