/*
 *   snortconf - configuration tool for snort.conf
 *
 *   Copyright (C) 2001 ManISec, Inc.
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* Yee ole includes (I put this all in one file for my sanity) */
#include "include.h"

/* a cheesey little function to make the selection bar == length for all options */
void snc_space(int len) {
	int i = (len + 8);

	for(; i < COLS ; ++i) {
		printw(" ");
	}
	printw("\n");
}

/* Bad adam, Bad adam!  Should have done this as "print function" and "work function", not
 all one piece as evidenced below. :) */
int ruleset_select_menu() {
	unsigned long int i, sel;
	long int linecount = 0;
	short int scr_wrk_around;
	char *print_ptr;
	
	int key;

	sel = rules_files.gl_offs;

	key = 'Z';
	if((unsigned long int)LINES < rules_files.gl_pathc) {
		do_popup("BUG WARNING: Terminal size too small - Work-around enabled!", HIT_OK);
		scr_wrk_around = TRUE;
	} else {
		scr_wrk_around = FALSE;
	}
			
	while(key != 'q') {
	
		clear();
		print_title_bar();
		if(scr_wrk_around == TRUE) {
			linecount = 0;
			if(sel > (unsigned long int) (LINES - 8)) {
				i = sel - (LINES - 8);
				if(rules_files.gl_pathv[i] == NULL) ++i;
			} else {
				i = rules_files.gl_offs;
			}
			
		} else {
			i = rules_files.gl_offs;
		}
		for(; i < rules_files.gl_pathc ; ++i) {
			
			if(rules_idx[i] == FALSE) {
				
				if(color == TRUE) {
					printw("[");
					attr_on(COLOR_PAIR(COLOR_RED), NULL);
					printw("OFF");
					standend();
					printw("] ");
				} else {
					printw("[OFF] ");
				}
			} else if(rules_idx[i] == TRUE) {
				if(color == TRUE) {
					printw("[");
					attr_on(COLOR_PAIR(COLOR_GREEN), NULL);
					printw("ON");
					standend();
					printw("]  ");
				} else {
					printw("[ON]  ");
				}
				
			}
			
			print_ptr = strrchr(rules_files.gl_pathv[i], '/');
			++print_ptr;

			if(sel == i) {
				sel_color_set();
				printw("%s", print_ptr); /* rules_files.gl_pathv[i]); */
				snc_space(strlen(rules_files.gl_pathv[i]));
				standend();
			} else {
				printw("%s\n", print_ptr);  /* rules_files.gl_pathv[i]);*/
				
			}
			if(scr_wrk_around == TRUE) {
				++linecount;
				if(linecount > (LINES - 8)) break;
			}
			
		}
		printw("\n");
		printw("      ");
		if(sel == rules_files.gl_pathc) {
			sel_color_set();
			printw("[Q]uit (return to main menu)");
			snc_space((strlen("[Q]uit (return to main menu)                 ")));
			standend();
		} else {
			printw("[Q]uit (return to main menu)\n");
		}
		standend();
		printw("\n");
		refresh();
		key = getch();
		key = tolower(key);

		switch(key) {
			
			case KEY_DOWN:
			case 'd':
			case 'j':
			case 'n':
				if(sel < rules_files.gl_pathc) ++ sel;
				break;
			case KEY_UP:
			case 'u':
			case 'k':
			case 'p':
				if(sel > rules_files.gl_offs) --sel;
				break;
			case 13:
			case ' ':
				if(sel == rules_files.gl_pathc) return 0;
				rules_idx[sel] = toggle_flag(rules_idx[sel]);
				break;
			case '?':
				menu_help_var("This is a list of available snort rules files that were found in your snort rules directory.  You may enable/disable them by selecting the rules file you wish, and pressing [ENTER] or [SPACE] while the file is selected\n\nPressing [V] will allow you to view/edit the selected rules file\n");
				break;
				
			      
		}
		
		
	}
	
	return 0;
}
