/*
 *   snortconf - configuration tool for snort.conf
 *
 *   Copyright (C) 2001 ManISec, Inc.
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* Yee ole includes (I put this all in one file for my sanity) */
#include "include.h"

/* gotta clean up curses mess before we exit, so wrapper function	*/
void snc_exit(int retval, char *err_msg) {
	endwin();
	if(err_msg != NULL) {
		fprintf(stderr, "ERROR: %s\n\n", err_msg);
	}
	exit(retval);
}

/* function to print yee ole "title bar" to top of curses screen */
void print_title_bar() {

	long int c;
	short int ver_len = strlen(VERSION);
	
	attr_on(A_REVERSE, NULL);
	
	printw("SnortConf ver %s - Press ? for help.", VERSION);
	       

	for(c = 1; c <= (COLS - (63 + ver_len)) ; ++c) {
		printw(" ");
	}
	
	
	printw("Copyright 2002 ManISec, Inc.");
		
	printw("\n\n");
	
	standend();
	
}

/* wrapper function to help avoid redundant code */
int toggle_flag(int flag) { 
	if(flag == TRUE) {
		return FALSE;
	}
	
	if(flag == FALSE) {
		return TRUE;
	}
	return -1;
}
void wsel_color_set(WINDOW *win) {

	if(color == TRUE) {
/*		attr_on(COLOR_PAIR(COLOR_CYAN)|A_BOLD, NULL); */
		wattron(win, A_REVERSE);
	} else {
		wattron(win, A_REVERSE);
	}
}
void sel_color_set() {

	if(color == TRUE) {
/*		attr_on(COLOR_PAIR(COLOR_CYAN)|A_BOLD, NULL); */
		attron(A_REVERSE);
	} else {
		attron(A_REVERSE);
	}
}

