/*
 *   seconf - a snort.conf configuration tool 
 *
 *   Copyright (C) Y2K (2000) A.L.Lambert
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* Yee ole #define's */
#define SVERSION "1.9.0"	/* what version of snort was this current with? */
#define VERSION "0.4.2-BETA"	/* what version of snortconf 			*/	

/* 
 * the below #define's were moved to config.h.in
 * Left here in case an accident with autoheader happens later.
 */

/*   

#define SNORT_CONFIG_FILE 	"/etc/snort/snort.conf"
#define SNORT_CONFIG_DIR 	"/etc/snort/"
#define SNORT_RULES_FILES 	"/etc/snort/rules/ *.rules"
#define SNORT_LOG_DIR 		"/var/log/snort"

*/

/* what kind of database's we got? */
#define MYSQL 	0
#define PGSQL 	1
#define MSSQL 	2
#define ODBC	3
#define ORACLE	4

/*  Define yee ole global variables */
short int cfg_basic;	/* what configuration mode are we in / basic or advanced 	*/
short int color;	/* do we have color in our curses?				*/
unsigned long int rules_idx[4096];	/* where we store "on/off" info for below	*/
char data[4096];	/* someplace global to store user input				*/
char err_msg[1024];		/* someplace to stick error messages if we need to		*/
glob_t rules_files;	/* a glob_t in which we store all yee ole rules files		*/

typedef struct {
	char snort_conf[1024];	/* what file do we want to write	*/
	char snort_cfgdir[1024];/* where be snort's main config dir	*/
	char snort_logdir[1024];/* where is snorts "logdir"		*/
	char rulesdir[1024];	/* where are yee ole rules located	*/
	char configfile[1024];	/* where is snortconf's config file	*/
	short int debug;	/* are we in debug mode?		*/
	short int quick;	/* should we do yee ole quick config?	*/
} Sconf;

Sconf cf;

/* A structure to store the "var NAME" values */
typedef struct {
	char home_net[4096];
	char external_net[4096];
	char smtp_servers[4096];
	char http_servers[4096];
	char sql_servers[4096];
	char dns_servers[4096];
	char shellcode_ports[4096];
	char http_ports[4096];
	char oracle_ports[4096];
} Nvars;

Nvars var;

/* yee ole configuration directives (flags and variables) */
typedef struct {
	char logdir[1024];
	char set_uid[1024];
	char set_gid[1024];
	int ghetto_msg;
	int ghetto_msg_type;
	int quiet;
	int dump_payload;
	char interface[1024];
	int stateful;
} Cfg_directives;

Cfg_directives cfg;


/* A structure to store data for the output plugins */
typedef struct {
	short int syslog;
	short int tcpdump;
	short int database;
	short int db_type;		/* see #define's at head of this file	*/
	char db_user[1024];
	char db_pass[1024];
	char db_name[1024];
	char db_host[1024];
	char db_port[1024];
	short int xml;
	short int unified;
	short int snmp;
} Oplug;

Oplug output;

/*  a global struct for the plugin configuration */
typedef struct  {		
	short int frag2;
	short int stream4;
	short int stream4_reass;
	short int http_decode;
	short int unidecode;
	short int rpc_decode;
	short int bo_detect;
	short int telnet_decode;
	short int spade;
	short int arp_spoof;
	short int arp_detect_host;
	short int portscan;
	char portscan_ignorehosts[4096];
} Pflags;

Pflags plug;

/*  Define our various functions */
int snc_init(int argc, char **argv);
void curs_init();
int snc_cleanup();

int snc_run();

void sel_color_set();
void wsel_color_set(WINDOW *win);

int snc_main_menu();
int snc_main_menu_advanced();
int snc_main_menu_basic();
int network_config_menu();
int general_config_menu();
int output_config_menu();
int preproc_config_menu();
int ruleset_select_menu();

int snc_regex(char *string, char *pattern);
	
int snc_write_config();
int snc_read_config();

void print_title_bar();
int toggle_flag(int flag);

void menu_help_main();
void menu_help_var(char *text);

int popup_yesno(char *msg, int def);

/* error checking stuffs	*/
int snc_check_cidr(char *ip);
int snc_check_ip(char *ip);
int snc_check_port(char *port);
int snc_check_validvar(char *var);
int snc_check_cidr_var(char *var);
int snc_check_dir(char *dirname);
int snc_check_file(char *filename);	

int snc_getopts(int argc, char **argv);

void snc_exit(int retval, char *err_msg);
int snc_read_snc_config();
